--- Pcap.c.old	2000-08-13 07:56:31.000000000 +0200
+++ Pcap.c	2009-09-26 00:42:15.000000000 +0200
@@ -54,6 +54,29 @@
 }
 
 static VALUE
+pcap_s_findalldevs(self)
+    VALUE self;
+{
+    pcap_if_t *alldevsp;
+    VALUE return_ary;
+    char pcap_errbuf[PCAP_ERRBUF_SIZE];
+
+    return_ary = rb_ary_new();
+
+    pcap_findalldevs(&alldevsp, pcap_errbuf);
+
+    if (alldevsp == NULL) // List is empty, probably an error
+           rb_raise(ePcapError, "%s", pcap_errbuf);
+
+    for (; alldevsp->next != NULL; alldevsp = alldevsp->next)
+            rb_ary_push(return_ary, rb_str_new2(alldevsp->name));
+
+    pcap_freealldevs(alldevsp);
+
+    return return_ary;
+}
+
+static VALUE
 pcap_s_lookupnet(self, dev)
     VALUE self;
     VALUE dev;
@@ -524,6 +547,26 @@
     return Qnil;
 }
 
+static VALUE
+capture_sendpacket(self, v_data, i_size)
+     VALUE self;
+     VALUE v_data;
+     VALUE i_size;
+{
+    struct capture_object *capture;
+
+    DEBUG_PRINT("capture_sendpacket");
+    GetCapture(self, capture);
+
+//    CheckClass(v_data, cString);
+//    CheckClass(i_size, cInteger);
+
+    int ret = pcap_sendpacket((pcap_t *)capture->pcap,
+			      STR2CSTR(v_data), NUM2INT(i_size));
+    return INT2NUM(ret);
+}
+
+
 /*
  * Filter object
  */
@@ -723,6 +766,7 @@
     /* define module Pcap */
     mPcap = rb_define_module("Pcap");
     rb_define_module_function(mPcap, "lookupdev", pcap_s_lookupdev, 0);
+    rb_define_module_function(mPcap, "findalldevs", pcap_s_findalldevs, 0);
     rb_define_module_function(mPcap, "lookupnet", pcap_s_lookupnet, 1);
     rb_global_variable(&rbpcap_convert);
     rb_define_singleton_method(mPcap, "convert?", pcap_s_convert, 0);
@@ -761,6 +805,8 @@
     rb_define_method(cCapture, "snaplen", capture_snapshot, 0);
     rb_define_method(cCapture, "stats", capture_stats, 0);
 
+    rb_define_method(cCapture, "sendpacket", capture_sendpacket, 2);
+
     /* define class Dumper */
     cDumper = rb_define_class_under(mPcap, "Dumper", rb_cObject);
     rb_define_singleton_method(cDumper, "open", dumper_open, 2);
@@ -780,11 +826,7 @@
     /*rb_define_method(cFilter, "&", filter_and, 1);*/
 
     /* define class PcapStat */
-    cPcapStat = rb_funcall(rb_cStruct, rb_intern("new"), 4,
-			   Qnil,
-			   INT2NUM(rb_intern("recv")),
-			   INT2NUM(rb_intern("drop")),
-			   INT2NUM(rb_intern("ifdrop")));
+    cPcapStat = rb_struct_define(NULL, "recv", "drop", "ifdrop", NULL);
     rb_define_const(mPcap, "Stat", cPcapStat);
 
     /* define exception classes */
